<?php
namespace NjFbCloud\Src;

use NjFbCloud\Src\Classes\View;
use NjFbCloud\Src\Cloud\GoogleDrive;

class Ajax {
    public function __construct()
    {
        // add_action( 'wp_ajax_njfb_cloud_run', array( $this, 'ajaxNjFbCloudRun' ) );
        add_action( 'wp_ajax_njfb_cloud_get_folders', array( $this, 'ajaxNjFbCloudGetFolders' ) );
        add_action( 'wp_ajax_njfb_cloud_sync_folders', array( $this, 'ajaxNjFbCloudSyncFolders' ) );
    }
    
    public function ajaxNjFbCloudGetFolders()
    {
        $cloud = isset( $_POST['cloud'] ) ? sanitize_key( $_POST['cloud'] ) : '';
        $this->validate( $cloud );
        
        $folders = njfb_cloud_get_cache_folders( $cloud );
        $selected_folders = njfb_cloud_get_settings_by_key( $cloud, 'selected_folders', array() );
        ob_start();
        njfb_cloud_render_tree( $cloud, $folders['files'], $selected_folders );
        $html = ob_get_clean();
        wp_send_json_success( array(
            'html' => $html
        ) );
    }

    public function ajaxNjFbCloudSyncFolders()
    {
        global $njfb_cloud_config;

        $cloud = isset( $_POST['cloud'] ) ? sanitize_key( $_POST['cloud'] ) : '';
        // $parent = isset( $_POST['parent'] ) ? $_POST['parent'] : 'root';
        // $page_token = isset( $_POST['page_token'] ) ? $_POST['page_token'] : null;
        $this->validate( $cloud );

        $obj = $njfb_cloud_config['supported_cloud'][$cloud]['obj'];
        //get folders from API
        $folders = $obj->getAllFolders();
        
        //add folders to FileBird
        // $old_cache = njfb_cloud_get_cache_folders( $cloud );
        njfb_cloud_folders_to_fb( $cloud, $folders );
        //save to cache
        njfb_cloud_set_cache_folders( $cloud, $folders );

        njfb_cloud_update_last_sync_folder( $cloud, time() );
        wp_send_json_success();
    }
    public function ajaxNjFbCloudRun()
    {
        check_ajax_referer('njfb_cloud', 'nonce', true);

        $cloud = isset( $_POST['cloud'] ) ? sanitize_key( $_POST['cloud'] ) : '';
        $this->runNow( $cloud );
        wp_send_json_success();
    }
    public function runNow($cloud) {
        if( empty( $cloud ) ) {
            return;
        }
        do_action('njfb_cloud_run_now', $cloud);
    }

    private function validate( $cloud )
    {
        check_ajax_referer('njfb_cloud', 'nonce', true);
        if( ! njfb_cloud_is_cloud_valid( $cloud ) )
        {
            wp_send_json_error( array(
                'mess' => __( 'Cloud service is not valid', 'njfb_cloud' )
            ) );
        }
    }
}
