<?php
namespace NjFbCloud\Src\Cloud;

abstract class Cloud {
    protected $id = null;

    // abstract public function getLatestFiles( $folder_id = null );
    // abstract public function getFolders();
    abstract public function maybeCreateRootFolder();
    abstract public function settingFields();

    public function __construct( $id )
    {
        $this->id = $id;
    }
    
    public function renderSettingForm()
    {
        if( is_null( $this->id ) || empty( $this->id ) ) {
            throw new \Error('id of Cloud Class is null, remember to call parent::__construct($id)');
        }
        $default_fields = array(
            'text' => array(
                'name' => '',
                'label' => '',
                'description' => '',
                'attr' => array(),
            ),
            'textarea' => array(
                'name' => '',
                'label' => '',
                'description' => '',
                'attr' => array()
            )
        );
        $fields = $this->settingFields();

        $html = '';
        // $html .= '<div class="njfb_cloud_s_row">';
        // $html .= '<label>'.esc_html__( 'Enable', 'njfb_cloud' ).'</label>';
        // $html .= '<input type="checkbox" name="njfb_cloud_settings['.esc_attr( $this->id ).'][enabled]" value="1" '.checked(njfb_cloud_get_settings_by_key( $this->id, 'enabled', '' ), 1, false).' />';
        // $html .= '</div>';
        foreach( $fields as $k => $field ) {
            $field = wp_parse_args( $field, array('type' => 'text') );

            if($field['type'] == 'custom_html') {
                $html .= $field['html'];
                continue;
            }

            if( ! isset($default_fields[$field['type']]) ) {
                continue;
            }
            
            if( empty($field['name']) ) {
                throw new \Error("Name of field is empty, please check");
            }
            // if( $field['name'] == 'enabled' ) {
            //     throw new \Error("Name of field can not be 'enabled");
            // }

            $field = wp_parse_args( $field, $default_fields[$field['type']] );
            $html .= '<div class="njfb_cloud_s_row">';
            $html .= '<label>'.$field['label'].'</label>';
            if( ! empty( $field['description'] ) ) {
                $html .= '<i>'.$field['description'].'</i>';
            }
            $name = sprintf( 'njfb_cloud_settings[%s][%s]', esc_attr( $this->id ), esc_attr( $field['name'] ) );
            $attr = ( count( $field['attr'] ) > 0 ) ? $this->renderAttr( $field['attr'] ) : '';
            switch ($field['type']) {
                case "text":
                    if( ! isset( $field['value'] ) ) {
                        $field['value'] = njfb_cloud_get_settings_by_key( $this->id, $field['name'], '' );
                    }
                    $html .= sprintf( '<input type="text" name="%s" value="%s" class="regular-text njfb_cloud_f_ctr" %s />', $name, esc_attr( $field['value'] ), $attr );
                    break;
                case "textarea":
                    if( ! isset( $field['value'] ) ) {
                        $field['value'] = njfb_cloud_get_settings_by_key( $this->id, $field['name'], '' );
                    }
                    $html .= sprintf( '<textarea class="njfb_cloud_f_ctr" name="%s" %s>%s</textarea>', $name, $attr, esc_textarea( $field['value'] ) );
                    break;
                case "checkbox":
                    $html .= sprintf( '<input type="checkbox" name="%s" value="1" %s />', $name, $attr );
                    break;
            }

            $html .= '</div>';
        } 
        return $html;
    }
    public function renderHiddenFields( $name, $data )
    {
        $html = '<div style="display: none">';
        if( is_array( $data ) ) {
            foreach( $data as $k => $v ) {
                $html .= sprintf( '<input type="hidden" name="njfb_cloud_settings[%s][%s][%s]" value="%s" />', $this->id, $name, $k, $v );
            }
        }
        $html .= '</div>';
        return $html;
    }
    private function renderAttr( $attr ) {
        $str = '';
        foreach( $attr as $k => $v ) {
            if( $v === true ) {
                $str .= $k;
            } else {
                $str .= $k . '="'.esc_attr( $v ).'" ';
            }
        }
        return $str;
    }
}
