<?php
namespace NjFbCloud\Src;


class Init {

    public function __construct()
    {
        $this->processCore();
        
        new Ajax();
        new SettingsPage();
    }
    private function processCore()
    {
        $this->processCloud();
        add_action( 'admin_init', array( $this, 'registerSettings' ) );
    }
    public function registerSettings()
    {
        register_setting( 'njfb_cloud_settings', 'njfb_cloud_settings', array('type' => 'array', 'default' => array()) );
    }
    private function processCloud()
    {
        global $njfb_cloud_config;
        foreach($njfb_cloud_config['supported_cloud'] as $id => $cloud) {
            $class = 'NjFbCloud\\Src\\Cloud\\' . $cloud['class'];
            if( class_exists( $class ) ) {
                $njfb_cloud_config['supported_cloud'][$id]['obj'] = new $class($id);
            } else {
                throw new \Error('Class NjFbCloud\\Src\\Cloud\\' . $cloud['class'] . ' Not Found');
            }
        }
    }
}
