<?php
namespace NjFbCloud\Src;

use NjFbCloud\Src\Classes\View;

class SettingsPage {

    private $settings_page = null;

    public function __construct()
    {
        if( is_admin() ) {
            add_action( 'admin_menu', array($this, 'registerSubMenu'), 12 );
            add_action( 'admin_enqueue_scripts', array( $this, 'loadAdminStyle' ) );
        }
    }
    public function registerSubMenu()
    {
        $this->settings_page = add_submenu_page( 
			'filebird-settings', __('FileBird Cloud', 'njfb_cloud'), __('Cloud', 'njfb_cloud'), 'manage_options', NJFB_CLOUD_PAGE_SLUG, array($this, 'cloudPageMenuCallback')
		);
    }
    public function cloudPageMenuCallback()
    {
        $selected_tab = njfb_cloud_selected_tab();
        View::load( 'admin/settings', array( 'selected_tab' => $selected_tab ) );
    }
    public function loadAdminStyle( $hook_suffix )
    {
        if($hook_suffix != $this->settings_page) {
            return;
        }
        wp_register_style( 'njfb_cloud_settings', NJFB_CLOUD_URL . 'assets/admin/css/settings.css', false, NJFB_CLOUD_VER );
        wp_enqueue_style( 'njfb_cloud_settings');

        wp_register_script( 'njfb_cloud_settings', NJFB_CLOUD_URL . 'assets/admin/js/settings.js', array('jquery') );
        wp_enqueue_script( 'njfb_cloud_settings' );
        wp_localize_script( 'njfb_cloud_settings', 'njfb_cloud_settings', array(
            'nonce' => wp_create_nonce( 'njfb_cloud' )
        ) );
    }
}
