jQuery(document).ready(function () {
    jQuery('.njfb_cloud_tab_panel').on('click', function () {
        var $this = jQuery(this)
        var parent = $this.closest('.njfb_cloud_tab')
        if (parent.length) {
            parent.find('.njfb_cloud_tab_panel').removeClass('active')
            $this.addClass('active')

            parent.find('.njfb_cloud_tab_content').removeClass('active')
            parent.find('[data-id="' + $this.attr('data-content') + '"]').addClass('active')
            return false;
        }
    })
    jQuery('.njfb_cloud_ggdrive_disconnect').on('click', function () {
        var $btn = this
        jQuery($btn).addClass('updating-message')
        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_ggdrive_disconnect',
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                location.reload()
            })
        return false;
    })
    jQuery('.njfb_cloud_ggdrive_resynchronize').on('click', function () {
        var $btn = jQuery(this)
        $btn.addClass('updating-message')

        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_ggdrive_resynchronize',
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                if (typeof res == 'string') {
                    res = JSON.parse(res)
                }
                $btn.removeClass('updating-message')
                if (res.success) {
                    var html = '<div id="fb_cloud_message" class="notice notice-success is-dismissible"><p>Success! The process is running in the background.</p><button type="button" onclick="jQuery(\'#fb_cloud_message\').remove()" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
                    jQuery('.wrap').prepend(html);
                } else {
                    alert(res.data.mess)
                }
            })
        return false;
    })
    jQuery('.njfb_cloud_dropbox_resynchronize').on('click', function () {
        var $btn = jQuery(this)
        $btn.addClass('updating-message')

        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_dropbox_resynchronize',
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                if (typeof res == 'string') {
                    res = JSON.parse(res)
                }
                $btn.removeClass('updating-message')
                if (res.success) {
                    var html = '<div id="fb_cloud_message" class="notice notice-success is-dismissible"><p>Success! The process is running in the background.</p><button type="button" onclick="jQuery(\'#fb_cloud_message\').remove()" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
                    jQuery('.wrap').prepend(html);
                } else {
                    alert(res.data.mess)
                }
            })
        return false;
    })
    jQuery('.njfb_cloud_dropbox_disconnect').on('click', function () {
        jQuery(this).addClass('updating-message')
        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_dropbox_disconnect',
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                location.reload()
            })
        return false;
    })
    jQuery('.njfb_cl_sync_f').on('click', function () {
        var $this = jQuery(this)
        var cloud = $this.attr('data-cloud');
        $this.addClass('updating-message')
        syncFolers(cloud, 'root', null, function (res) {
            location.reload()
        })
        return false;
    })
    //initial folders
    jQuery('.njfb_cl_listf').each(function (index, el) {
        var $this = jQuery(el)
        if ($this.html() == '') {
            getFolders($this.attr('data-cloud'), function (res) {
                if (res.success) {
                    $this.append(res.data.html)
                }
            })
        }
    })
    function syncFolers(cloud, parent, page_token, on_complete) {
        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_sync_folders',
                cloud: cloud,
                parent: parent,
                page_token: page_token,
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                if (res.success) {
                    on_complete(res)
                } else {
                    alert('Error while syncing folders: ' + res.data.mess);
                }
            })
            .fail(function (res) {
                alert('Network error while syncing Folders');
            })
    }
    function getFolders(cloud, on_done) {
        jQuery.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                action: 'njfb_cloud_get_folders',
                cloud: cloud,
                nonce: njfb_cloud_settings.nonce
            }
        })
            .done(function (res) {
                on_done(res);
            })
            .fail(function (res) {
                alert('Network error while getting Folders');
            })
    }
})