<?php
namespace NjFbCloud;

$njfb_cloud_config = require_once NJFB_CLOUD_PATH . '/config.php';
$njfb_cloud_settings = null;

require_once NJFB_CLOUD_PATH . '/Src/Interface/General.php';
require_once NJFB_CLOUD_PATH . '/Src/Interface/Google.php';

require_once NJFB_CLOUD_PATH . '/Src/Enum/GoogleDriveMime.php';
require_once NJFB_CLOUD_PATH . '/Src/Enum/CloudType.php';

require_once NJFB_CLOUD_PATH . '/helpers.php';

require_once NJFB_CLOUD_PATH . '/Src/Jobs/Job.php';
require_once NJFB_CLOUD_PATH . '/Src/Jobs/GoogleDriveJob.php';

require_once NJFB_CLOUD_PATH . '/Src/Hooks.php';

require_once NJFB_CLOUD_PATH . '/Src/Classes/View.php';
require_once NJFB_CLOUD_PATH . '/Src/Classes/GoogleDriveApi.php';
require_once NJFB_CLOUD_PATH . '/Src/Classes/GoogleApiUploadResumable.php'; 
require_once NJFB_CLOUD_PATH . '/Src/Classes/GoogleApiSyncFolders.php'; 

require_once NJFB_CLOUD_PATH . '/Src/Classes/DropboxApi.php'; 

require_once NJFB_CLOUD_PATH . '/Src/Plugin.php';

require_once NJFB_CLOUD_PATH . '/Src/Cloud/Cloud.php';
foreach($njfb_cloud_config['supported_cloud'] as $id => $cloud) {
    $file = NJFB_CLOUD_PATH . '/Src/Cloud/'.$cloud['class'].'.php';
    if(file_exists($file)) {
        require_once $file;
    }
}

require_once NJFB_CLOUD_PATH . '/Src/Ajax.php';
require_once NJFB_CLOUD_PATH . '/Src/SettingsPage.php';

require_once NJFB_CLOUD_PATH . '/Src/Init.php';

add_action( 'plugins_loaded', 'NjFbCloud\njfb_cloud_plugins_loaded' );
function njfb_cloud_plugins_loaded() {
    new \NjFbCloud\Src\Init();
}

// add_action( 'init', 'NjFbCloud\njfb_cloud_init' );
// function njfb_cloud_init() {
// }

register_activation_hook( NJFB_CLOUD_FILE, array( 'NjFbCloud\\Src\\Plugin', 'activate' ) );
register_deactivation_hook( NJFB_CLOUD_FILE, array( 'NjFbCloud\\Src\\Plugin', 'deactivate' ) );
